// Copyright 2013, University of Freiburg,
// Image Analysis Lab
// Author: Olaf Ronneberger <ronneber>

/**
 * Some timings of our sorting algorithms.
 */
#include <sys/time.h>
#include <vector>
#include <iostream>
#include "./Sorter.h"


/**
 * Sort arrays of various sizes using MinSort.
 */
int main(int argc, char** argv) {
  // Time Min-Sort.
  if (true) {
    int step = 1000;
    for (int n = step; n <= 60 * step; n += step) {
      std::vector<int> array(n);
      for (int j = 0; j < n; j++) { array[j] = n - j; }
      timeval startTime;
      gettimeofday(&startTime, 0);
      Sorter::minSort(&array);
      timeval endTime;
      gettimeofday(&endTime, 0);
      float neededSeconds = (endTime.tv_sec - startTime.tv_sec)
          + 0.000001 * (endTime.tv_usec - startTime.tv_usec);
      std::cout << n << "\t" << neededSeconds << std::endl;
    }
  }
  return 0;
}

